#include <reg51.h>	
#include <string.h>
sbit rs = P3^0;		// declare P3.0 as rs pin
sbit en = P3^2;		// declare p3.2 as enable pin
sbit rw = P3^1;		// declare p2.6 as read/write pin
sbit b = P2^7;		// busy flag	
sbit op=P3^7;		// output pin 
sbit pin=P3^6;		// input pin for repeat no repeat mode
sbit rmt=P3^5;		// input pin for remote or keypad operation	
unsigned char ascii[10] = {0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38,0x39};
unsigned char data byte; 
unsigned int i=0;j=0,k=0,ontime=0,offtime=0,t1=0,t2=0,tmp1,tmp2,flag,sflag; 	
void writecmd(unsigned char a);		// function to send command to LCD
void writedat(unsigned char b);		// function to send data to LCD
void busy();					// function to check LCD is busy or not
void writestr(unsigned char *s);	// function to write string on LCD
void keydly()					// function for key debounce delay
 {
 	int y,z;
	for(y=0;y<50;y++)
	 for(z=0;z<1000;z++);
  }
void writecmd(unsigned char a)
{
	busy();					// check for LCD is busy or not
	rs = 0;					// clear rs pin for command
	rw = 0;					// clear rw pin to write
	P2 = a;					// send command character
	en = 1;					// strob LCD
	en = 0;	
}
void writedat(unsigned char b)
{
	busy();					// check for LCD is busy or not
	rs = 1;					// set rs pin for data
	rw = 0;					// clear rw pin to write
	P2 = b;					// send data character
	en = 1;					// strob LCD
	en = 0;		
}
void busy()
{
	en = 0;					// disable display
	P2 = 0xFF;				// configure P0 as input
	rs = 0;					// clear rs pin for command
	rw = 1;					// set rw pin to read
	while(b==1)
	{
	 en=0;					// strobe LCD till P0.7 is 1
	 en=1;
	}
	en=0;
}
void writestr(unsigned char *s)
{
	unsigned char l,i;
	l = strlen(s);				// get the length of string
	for(i=0;i<l;i++)
	{
		writedat(*s);			// write every char one by one
		s++;		
	}
}
void inctime()
  {
  	 t2=0;					// minimum limit flag cleared
	 if(k==1)				// check to increase ontime or offtime
	   {
	   	 if(offtime<60) offtime++;	// increase offtime till 60
		 else 
		   {
		   		writecmd(0xC0);
				writestr("60-max limit  ");	// if it is 60 display message
				t1=1;				// and set max limit falg			
			}
		  i=offtime/10;					// separate upper and
		  j=offtime%10;					// lower digits
		}
	  else					// if ontime-offtime flag is not 1
	  	{
		 if(ontime<60) ontime++;	// increase ontime till 60
		 else 
		             {
		   		writecmd(0xC0);			// same as above
				writestr("60-max limit  ");
				t1=1;				
			}
		  i=ontime/10;
		  j=ontime%10;
		  }	 	  
	  if((t1==0)&& (t2==0))				// if max limit is not reached
	    {
	   		writecmd(0xC0);			// print ontime/offtime sec
	   		writestr("press enter:");
			writedat(ascii[i]);		// as one by one digit
	   		writedat(ascii[j]);	
			writestr("  ");		
		}
  }	
void dectime()						// similar to above function
  {
  	 t1=0;
	 if(k==1)
	   {
	   	 if(offtime>1) offtime--;
		 if(offtime<=1) 
		   {
		   		writecmd(0xC0);
				writestr("01-min limit  ");
				t2=1;				
			}
		  i=offtime/10;
		  j=offtime%10;
		}
	  else
	  	{
		 if(ontime>1) ontime--;
		 if(ontime<=1) 
		   {
		   		writecmd(0xC0);
				writestr("01-min limit  ");
				t2=1;				
			}
		  i=ontime/10;
		  j=ontime%10;
		  }	  
	 if((t1==0)&& (t2==0))
	    {
	   		writecmd(0xC0);
			writestr("press enter:");
	   		writedat(ascii[i]);
	   		writedat(ascii[j]);	
			writestr("  ");		
		}
  } 
void enter()				// enter ontime & offtime and 
  {							// display message
  	k++;					// increase count to enter off time
	if(k==1)				// first time
	  {
		writecmd(0x80);
		writestr("Set OFF time and"); 		// display message and
		writecmd(0xC0);						// show value 00
		writestr("press enter:");
		writedat(0x30);
		writedat(0x30);
		i=j=0;
	  }
	else if(k==2)							// second time
	  {
	  	writecmd(0x01);						// clear LCD screen and 
		writestr("Press start");			// display message
		sflag=1;							// set start flag
		k=0;								// reset counter
	  }
  }	
void delay1sec()						// generate delay of exact 1 sec
  {
    int x;
	TL1 = 0xBF;
	TH1 = 0x3C;
	TR1 = 1;
	for(x=0;x<=20;x++)
	  {
		while(TF1==0);
		TF1 = 0;
		TL1 = 0xBF;
		TH1 = 0x3C;
	  }
	TR1 = 0;
  }
void start()
  {
  	  int a,b;
	  tmp1=ontime;					// save ontime and offtime values
	  tmp2=offtime;
 back:writecmd(0x80);
	  writestr("Device ON: ");		// display message
	  op=1;	  					// switch ON relay
	  for(a=tmp1;a>0;a--)			// start countdown
	    {
			i=a/10;
			j=a%10;
			writecmd(0x8B);
			writedat(ascii[i]);		// change the display digits
	   		writedat(ascii[j]);		// on LCD after
			delay1sec();			// every sec
		}
	  op=0; 						// switch OFF relay
	  writecmd(0x80);
	  writestr("Device OFF:");	  	  
	  for(b=tmp2;b>0;b--)			// start countdown again
	    {
			i=b/10;
			j=b%10;
			writecmd(0x8B);
			writedat(ascii[i]);		// display digits after
	   		writedat(ascii[j]);	
			delay1sec();			// 1 sec delay
		}
	  if(pin==1) goto back;			// repeat continuously for repeat mode
	  else 						// otherwise 
	    {
			flag=1;				// set flag
			ontime=0;			// clear ontime and offtime
			offtime=0;			// and stop operation
		 }
	}
void takeinput() interrupt 2	// for remote operation mode
  {
  	byte=P1;					// take input from P1 when interrupt arrives  	
  }						
main()
{
	TMOD=0x10;
	P3=0x68;					// set keypad operation and repeat mode	
	P2=0x00;					// P2 as output
	writecmd(0x3C);				// Initialize LCD					
	writecmd(0x0E);
bgin:writecmd(0x01);			// clear display
	writestr("Set ON time and");// display message and
	writecmd(0xC0);
	writestr("press Enter:");
	writedat(0x30);				// value as 00
	writedat(0x30);
	IT1=1;						// enable interrupt on falling edge
	IE=0x84;					// enable ext interrupt 1
	flag=0;						// clear flag for entering values
	sflag=0;					// start flag cleard
agin:P1=0xFF;					// P1 as input
	byte=0xFF;					// initialize byte variable
	if(rmt==1) while(P1==0xFF);	// for keypad mode check status of P1
	else while(byte==0xFF);		// for remote mode check byte content
	if(rmt==1) byte=P1;			// if keypad mode save input in byte	
	switch(byte)				// compare the content of byte
	  {
	  	case 0xFE:				// for 1st key 				  
				if(sflag==1) start();// if start flag is set start
				else				 // operation else
				  { 					
				    writecmd(0xC0);	 // display message
					writestr("time is not set");
					flag=1;
				  }
				break;
		case 0xFD:
				inctime();		// for 2nd key increase time			
				break;
		case 0xFB:
				dectime();		// for 3rd key decrease time			
				break;
		case 0xF7: 
				enter();		// for 4th key enter values			
				break;
		}
	 keydly();					// key debounce delay
	 if(flag==0) goto agin;		// till start button is not pressed change and
	 else goto bgin;			// enter values otherwise start operation again
 }
